'use strict';
var ssha = require("ssha");

/**
 * Login action
 */
module.exports = function (req, res) {

    var params = req.params.all();
    var pass = params.password;

    var criteria = {};

    if(params.uid){
        criteria.uid = params.uid;
    }
    else {
        return res.serverError();
    }

    waterlock.engine.findAuth(criteria, function (err, user) {
        if (err) {
            if (err.code === 'E_VALIDATION') {
                return res.status(400).json(err);
            } else {
                return res.serverError(err);
            }
        }
        if (user) {
            if (ssha.verify(pass, user.auth.password)) {
                waterlock.cycle.loginSuccess(req, res, user);
            } else {
                waterlock.cycle.loginFailure(req, res, user, {error: 'Invalid login or password'});
            }
        } else {
            waterlock.cycle.loginFailure(req, res, null, {error: 'user not found'});
        }
    });
};
