'use strict';
var ssha = require('ssha');

/**
 * Login action
 */
module.exports = function (req, res) {

    var params = req.params.all();

    var auth_criteria = { uid: params.uid };
    var auth_attr = {
        uid: params.uid,
        email: params.email,
        password: params.password
    };

    //set all user attrs to params
    var user_attr = params;
    //remove ones we dont need
    delete user_attr.uid;
    delete user_attr.email;
    delete user_attr.password;
    delete user_attr.confirmPassword;
    delete user_attr.id;

    Auth.findOne(auth_criteria).exec(function (err, auth) {
        if( err ) {
            return res.serverError({error: "Error creating user"});
        }
        else if( auth ) {
            return res.serverError({error: "Error user already exists"});
        }
        else {
            waterlock.engine.findOrCreateAuth(auth_criteria, auth_attr, function (err, user) {
                if( err ) {
                    return res.serverError({error: "Error creating authentication object"});
                }
                if(!user) {
                    return res.serverError({error: "Error finding new user"});
                }
                //populate all passed user keys
                Object.keys(user_attr).forEach(function (key) {
                    user[key] = user_attr[key];
                });

                //populate roles via sails add() method
                params.roles.forEach(function (roleId) {
                   user.roles.add(roleId);
                });

                user.save();

                return res.json(user);
            });
        }
    })
};
